#
# Possible targets:
# - build (default) -  builds everything
# - clean - cleans everything
#
# Please review Makefile.VS.common first.
#

build : build_all
build_all : build_all_core build_all_cpp build_python build_services

build_all_core : build_core build_core_tests build_core_examples

build_core :
	cd core
	nmake /F Makefile.VS
	cd ..

build_core_tests :
	cd core\tests
	nmake /F Makefile.VS build
	cd ..\..

build_core_examples :
	cd core\examples\calculator
	nmake /F Makefile.VS
	cd ..\performance
	nmake /F Makefile.VS
	cd ..\print
    nmake /F Makefile.VS
	cd ..\..\..

build_all_cpp : build_cpp build_cpp_tests build_cpp_examples

build_cpp :
	cd cpp
	nmake /F Makefile.VS
	cd ..

build_cpp_tests :
	cd cpp\tests
	nmake /F Makefile.VS build
	cd ..\..

build_cpp_examples :
	cd cpp\examples\calculator
	nmake /F Makefile.VS
	cd ..\flow_control
	nmake /F Makefile.VS
	cd ..\print
	nmake /F Makefile.VS
	cd ..\subscription
	nmake /F Makefile.VS
	cd ..\..\..

build_python :
	cd python3
	nmake /F Makefile.VS
	cd ..

build_services : build_broker

build_broker :
	cd services\broker
	nmake /F Makefile.VS
	cd tests
	nmake /F Makefile.VS
	cd ..\..\..


clean : clean_all
clean_all : clean_all_core clean_all_cpp clean_all_python clean_services

clean_all_core : clean_core clean_core_tests clean_core_examples

clean_core :
	cd core
	nmake /F Makefile.VS clean_all
	cd ..

clean_core_tests :
	cd core\tests
	nmake /F Makefile.VS clean
	cd ..\..

clean_core_examples :
	cd core\examples\calculator
	nmake /F Makefile.VS clean
	cd ..\performance
	nmake /F Makefile.VS clean
	cd ..\print
	nmake /F Makefile.VS clean
	cd ..\..\..

clean_all_cpp : clean_cpp clean_cpp_tests clean_cpp_examples

clean_cpp :
	cd cpp
	nmake /F Makefile.VS clean_all
	cd ..

clean_cpp_tests :
	cd cpp\tests
	nmake /F Makefile.VS clean
	cd ..\..

clean_cpp_examples :
	cd cpp\examples\calculator
	nmake /F Makefile.VS clean
	cd ..\flow_control
	nmake /F Makefile.VS clean
	cd ..\print
	nmake /F Makefile.VS clean
	cd ..\subscription
	nmake /F Makefile.VS clean
	cd ..\..\..

clean_all_python :
	cd python3
	nmake /F Makefile.VS clean_all
	cd ..

clean_services : clean_broker

clean_broker :
	cd services\broker
	nmake /F Makefile.VS clean
	cd tests
	nmake /F Makefile.VS clean
	cd ..\..\..
