// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_CHANNEL_HOLDER_H_INCLUDED
#define YAMICORE_CHANNEL_HOLDER_H_INCLUDED

#include <cstddef>

namespace yami
{

namespace details
{

class channel;
class channel_holder
{
public:

    void init();
    void set(channel * ch, std::size_t & new_sequence_number);
    channel * get_channel() { return ch_; }
    std::size_t get_sequence_number() const { return sequence_number_; }

    void reserve() { reserved_ = true; }
    bool is_reserved() const { return reserved_; }
    void clean();

private:

    std::size_t sequence_number_;
    channel * ch_;
    bool reserved_;
};

} // namespace details

} // namespace yami

#endif // YAMICORE_CHANNEL_HOLDER_H_INCLUDED
