// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_DETAILS_FWD_H_INCLUDED
#define YAMICORE_DETAILS_FWD_H_INCLUDED

namespace yami
{

namespace core
{

// frequently used core types:
class allocator;
class parameters;
class serializable;

} // namespace core

namespace details
{

struct entry;

class fsm_common;
class get_serialize_buffer_size_fsm;
class serialize_fsm;
class deserialize_fsm;

struct outgoing_frame;
struct incoming_frame;
struct incoming_message_frame_list;

class channel;
class channel_holder;
class listener;
class channel_group;
class mutex;
struct options;

enum protocol
{
    proto_tcp,
    proto_udp
#if !defined(_WIN32)
    , proto_unix,
    proto_file
#endif // !_WIN32
#ifdef YAMI4_WITH_QNX
    , proto_qnx
#endif // YAMI4_WITH_QNX
#ifdef YAMI4_WITH_OPEN_SSL
    , proto_tcps
#endif // YAMI4_WITH_OPEN_SSL
};

enum io_direction { none, input, output, inout };

class dump_sink;

} // namespace details

} // namespace yami

#endif // YAMICORE_DETAILS_FWD_H_INCLUDED
