// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#include <yami4-core/fatal_errors.h>
#include <cstdio>
#include <cstdlib>

using namespace yami;
using namespace yami::core;
using namespace yami::details;

namespace // unnamed
{

fatal_error_function custom_handler = NULL;

} // unnamed namespace

void yami::core::register_fatal_error_handler(fatal_error_function handler)
{
    custom_handler = handler;
}

void yami::details::fatal_failure(const char * source_file, int line_number)
{
    if (custom_handler != NULL)
    {
        try
        {
            custom_handler(source_file, line_number);
        }
        catch (...)
        {
            // ignore
        }
    }
    else
    {
#ifndef YAMI4_NO_TERMINAL_IO
        std::printf("YAMI4 fatal error, see %s:%d\n",
            source_file, line_number);
#endif // YAMI4_NO_TERMINAL_IO
    }

    std::abort();
}
