// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_INCOMING_MESSAGE_FRAME_LIST_H_INCLUDED
#define YAMICORE_INCOMING_MESSAGE_FRAME_LIST_H_INCLUDED

#include <cstddef>

namespace yami
{

namespace details
{

struct incoming_frame;
struct incoming_message_frame_list
{
    int message_id;
    std::size_t header_size;

    bool check_completeness;

    incoming_frame * first_frame;
    incoming_frame * last_frame;

    incoming_message_frame_list * next_list;
};

} // namespace details

} // namespace yami

#endif // YAMICORE_INCOMING_MESSAGE_FRAME_LIST_H_INCLUDED
