// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_IO_ERROR_HANDLER_H_INCLUDED
#define YAMICORE_IO_ERROR_HANDLER_H_INCLUDED

#include <yami4-core/core.h>

namespace yami
{

namespace details
{

void handle_io_error(
    const char * prefix,
    core::io_error_function io_error_callback,
    void * io_error_callback_hint);

void handle_io_error_with_code(
    const char * prefix,
    int error_code,
    core::io_error_function io_error_callback,
    void * io_error_callback_hint);

} // namespace details

} // namespace yami

#endif // YAMICORE_IO_ERROR_HANDLER_H_INCLUDED
