// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_OUTGOING_FRAME_H_INCLUDED
#define YAMICORE_OUTGOING_FRAME_H_INCLUDED

#include <yami4-core/core.h>
#include <cstddef>

namespace yami
{

namespace details
{

struct outgoing_frame
{
    // primary information

    const char * data;
    std::size_t size;

    // all following fields are internally managed by channel

    core::message_progress_function progress_callback;
    void * progress_hint;

    std::size_t byte_count; // number of bytes from the beginning of message
    std::size_t total_byte_count; // size of the whole message

    // used for proper queue management
    std::size_t priority;
    bool close_flag;
    outgoing_frame * next;
};

} // namespace details

} // namespace yami

#endif // YAMICORE_OUTGOING_FRAME_H_INCLUDED
