// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#include "mutex.h"

using namespace yami;
using namespace details;

void mutex::init()
{
    InitializeCriticalSection(&mtx_);
}

void mutex::clean()
{
    DeleteCriticalSection(&mtx_);
}

void mutex::lock()
{
    EnterCriticalSection(&mtx_);
}

void mutex::unlock()
{
    LeaveCriticalSection(&mtx_);
}
