// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICORE_MUTEX_H_INCLUDED
#define YAMICORE_MUTEX_H_INCLUDED

#include <yami4-core/dll.h>
#include <Windows.h>

namespace yami
{

namespace details
{

class DLL mutex
{
public:
    void init();
    void clean();

    void lock();
    void unlock();

private:

    CRITICAL_SECTION mtx_;
};

} // namespace details

} // namespace yami

#endif // YAMICORE_MUTEX_H_INCLUDED
