// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICPP_INCOMING_MESSAGE_INFO_H_INCLUDED
#define YAMICPP_INCOMING_MESSAGE_INFO_H_INCLUDED

#include <yami4-cpp/parameters.h>
#include <string>
#include <vector>

namespace yami
{

namespace core
{
class parameters;
} // namespace core

namespace details
{

struct incoming_message_info
{
    incoming_message_info()
    : core_header(NULL), body(NULL), raw_buffer(NULL) {}

    std::string source;
    std::string object_name;
    std::string message_name;
    long long message_id;

    core::parameters * core_header;

    // either body or raw_buffer has the content
    parameters * body;
    std::vector<char> * raw_buffer;
};

} // namespace details

} // namespace yami

#endif // YAMICPP_INCOMING_MESSAGE_INFO_H_INCLUDED
