// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#include "number_generator.h"

using namespace yami;
using namespace details;

number_generator::number_generator()
    : current_id_(0), mt_(rd_())
{
}

long long number_generator::get_next_id()
{
    std::lock_guard<std::mutex> lock(mtx_);

    return ++current_id_;
}

unsigned int number_generator::operator()()
{
    std::lock_guard<std::mutex> lock(mtx_);

    return mt_();
}
