// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMICPP_OPTIONS_H_INCLUDED
#define YAMICPP_OPTIONS_H_INCLUDED

#include <cstddef>

namespace yami
{

class parameters;

namespace details
{

struct cpp_options
{
    void init(const parameters & params);

    bool run_internal_threads;
    std::size_t dispatcher_threads;

    std::size_t connection_retries;
    std::size_t connection_retry_delay_spread;

    std::size_t outgoing_high_water_mark;
    std::size_t outgoing_low_water_mark;
    std::size_t incoming_high_water_mark;
    std::size_t incoming_low_water_mark;

    bool deliver_as_raw_binary;

    std::size_t default_failover_timeout;
};

} // namespace details

} // namespace yami

#endif // YAMICPP_OPTIONS_H_INCLUDED
