// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMI4BROKER_MESSAGING_H
#define YAMI4BROKER_MESSAGING_H

#include "broker.h"

#include <yami4-core/parameters.h>

#include <string>

namespace broker
{

// Initializes the messaging part with the given listener endpoint.
// The broker will be initialized in the "warm-up" mode.
void init_messaging(const yami::core::parameters & options,
    const std::string & listener,
    const std::string & announce_file_name,
    overflow_policy subscription_overflow_policy);

// Finishes the warm-up mode.
void allow_incoming();

} // namespace broker

#endif // YAMI4BROKER_MESSAGING_H
