// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMI4SERVICES_UTILS_H
#define YAMI4SERVICES_UTILS_H

#include <yami4-core/core.h>
#include <yami4-core/parameters.h>

#include <string>

namespace utils
{

// Trims whitespace on both sides.
std::string trim(const std::string & s);

// To lowercase.
std::string to_lower(const std::string & s);

// Helper for extracting string fields.
yami::core::result get_string(
    const yami::core::parameters & params, const char * field_name,
    std::string & out_result);

// Converts result codes into messages.
std::string result_to_string(yami::core::result res);

} // namespace logger

#endif // YAMI4SERVICES_UTILS_H
