// Copyright Maciej Sobczak 2008-2022.
// This file is part of YAMI4.
// See the package-level LICENSE.txt file.

#ifndef YAMI4NAMES_STORAGE_H
#define YAMI4NAMES_STORAGE_H

#include "../common/log.h"

#include <map>
#include <string>

namespace name_server
{

typedef std::map<std::string, std::string> name_map;

// Initializes the storage module.
void init_storage(const std::string & data_directory);

// Stores new binding.
void store(const std::string & object_name, const std::string & location);

// Resolves a given name. Returns empty string if name is not found.
const std::string & resolve(const std::string & object_name);

// Returns the access to the local cache.
const name_map & name_mapping();

} // namespace name_server

#endif // YAMI4NAMES_STORAGE_H
